#include <stdio.h>
#include <stdlib.h>

int main()
{
    int n,h;
    printf("Unesite visinu pa sirinu vodopada: ");
    scanf("%d%d",&h,&n);
    int a[h][n];
    int i,j;
    for(i=0;i<h;i++)
    {
        for(j=0;j<n;j++)
        {
            int k;
            printf("Unesite vrednost za %d red i %d vrstu matrice: ",i+1,j+1);
            scanf("%d",&k);
            a[i][j]=k;
        }
    }
    int b[n];
    for(i=0;i<n;i++)
    {
        b[i]=1;
    }

    int z;
    for(i=0;i<h;i++)
    {
        int l;
        for(j=0;j<n;j++)
        {
            z=0;
            if(a[i][j]==0)
            {
                l=j;
                while(j<n && a[i][j]==0)
                {
                    z+=b[j];
                    j++;
                }
                if(j<n)
                {
                    if(l==0)
                        b[j]+=z;
                    else
                    {
                        if(z%2==0)
                        {
                            b[j]+=z/2;
                            b[l-1]+=z/2;
                        }

                    else
                    {
                        if((i+1)%2==1)
                        {
                            b[j]+=z/2;
                            b[l-1]+=z/2+1;
                        }
                        else
                        {
                            b[l-1]+=z/2;
                            b[j]+=z/2+1;
                        }
                    }

                }
            }
            else
                b[l-1]+=z;
        }
        }

        for(j=0;j<n;j++)
        {
            if(a[i][j]==0)
                {
                    b[j]=0;
                }
        }

    }

    printf("Ovako izgleda raspored voda:\n");
    for(i=0;i<n;i++)
    {
        printf("%d  ",b[i]);
    }
}